      subroutine builma(iprob,value,nvalu,idest,nelem,ndofn,
     .                  nnode,nnodw)
c**********************************************************************
c                 
c**** This routine constructs the matrix for problem IPROB 
c                 
c**********************************************************************
      implicit  none
      include  'MatMan.h'
      integer   iprob,nvalu,nevaw,nelem,ndofn,nnode,nnodw
      integer   idest(*)
      integer   p_mat,p_lpn                                 ! pointer
      real*8    value(*)

      if(sofam(iprob).eq.1) then
        call spoias(%val(ialpn+(iprob-1)*lengp),p_lpn)
        call buildi(%val(p_lpn),iprob,value,nvalu,idest)    ! Direct methods
      else if(sofam(iprob).eq.2) then
        call spoias(%val(iamat+(iprob-1)*lengp),p_mat)
        nevaw=ndofn*nnode+nnodw-nnode
        call stomat(value,nvalu,nevaw,idest,nelem,          ! EE Iterative methods
     .              ksymm(iprob),p_mat,lengp,kmadi(iprob))
      else if(sofam(iprob).eq.3) then
        call spoias(%val(ialpn+(iprob-1)*lengp),p_lpn)
        call spamat(%val(p_lpn),iprob,value,nvalu,idest)    ! SK Iterative methods
      end if

      end
