      subroutine putmat(amatr,elmat,nvalo,nevaw,ksymm)
c*****************************************************************************
c
c**** This routine adds the elemental matrices for iterative solvers
c
c*****************************************************************************
      implicit none
      integer   nvalo,nevaw,ksymm,ievaw,jevaw,icolu
      real*8    amatr(nevaw*nevaw), elmat(nvalo,nvalo)

      icolu=0
      if (ksymm.eq.1) then                                  ! Non symmetric
        do jevaw=1,nevaw
          do ievaw=1,nevaw
            amatr(ievaw+icolu)=amatr(ievaw+icolu)+elmat(ievaw,jevaw)
          end do
          icolu=icolu+nevaw
        end do
      else                                                  ! Symmetric
        do jevaw=1,nevaw
          do ievaw=jevaw,nevaw
            amatr(ievaw+icolu)=amatr(ievaw+icolu)+elmat(ievaw,jevaw)
          end do
          icolu=icolu+nevaw-jevaw
        end do
      end if

      end
