      subroutine baubsu(n,l,c,m,z,x,iu)
c****************************************************************************
c
c*** This routine performs a backward substitution to solve the system `Cx=z',
c*** `n' being the number of equations, `l' half the bandwidth,`m' the number
c*** of substitutions to be performed and `iu' the logical unit where errors
c*** have to be printed. 'C' is an upper triangular matrix with C(i,i)=1.
c
c****************************************************************************
      implicit real*8(a-h,o-z)
      real*8  c(2*l+1,n),z(n,m),x(n,m)
      
      id=l+1
      do is = 1,m
        x(n,is) = z(n,is)
        do i = n-1,1,-1
          x(i,is) = z(i,is)
          k2 = i+l
          if (k2.gt.n) k2 = n
          do k = i+1,k2
            x(i,is) = x(i,is)-c(id+i-k,i)*x(k,is)
          end do
        end do
      end do

      end
