      subroutine skyli0(neqns,gstdi,gstup,gstlo,eload,
     .                  lpont,nsist,ksymm,kresl,lures)
c***********************************************************************
c
c**** This routine solves the set of linear equations 
c
c***********************************************************************
      implicit real*8(a-h,o-z)
      integer   lures
      integer   lpont(*)
      real*8    gstdi(neqns),
     .          gstlo(*),                                   !gstlo(lpont(neqns)),
     .          gstup(*),                                   !gstup(lpont(neqns)),
     .          eload(neqns,nsist)
c
c*** Factorize matrix if neccesary
c
      isymm=0                           ! Non symmetric (ksymm=1)
      if (ksymm.eq.0) isymm=1           ! Symmetric
      if(kresl.eq.1)
     .  call skytri(gstdi,gstlo,gstup,isymm,lpont,
     .  neqns,lures)
c
c*** Solve the equations 
c
      do isist=1,nsist
        call skybak(gstdi,gstlo,gstup,lpont,neqns,
     .    eload(1,isist),lures)
      end do
      
      end
