      subroutine assdia(lnods,elmat,adiag,nnode,nnodt,nnodw,
     .                  nevaw,ndofn,npoin,npois,nequa,ksymm)
c****************************************************************************
c
c**** This routine assembles the diagonal for pre-conditioning
c
c****************************************************************************
      implicit none
      integer   nnode,nnodt,nnodw,nevaw,ndofn,npoin,npois,
     .          nequa,ksymm,icolu,ntotm,ievat,inode,itott,
     .          idofn,ipoin
      integer   lnods(nnodt)
      real*8    adiag(nequa), elmat(nevaw*nevaw)

      icolu=0
      ntotm=nequa-npois                                     ! = ndofn*npoin
      if (ksymm.eq.1) then                                  ! Non symmetric
        ievat=0                                               
        do inode=1,nnode                                    ! Main assembly 
          ipoin=lnods(inode)
          if(ipoin.ne.0) then
            itott=(ipoin-1)*ndofn   
            do idofn=1,ndofn               
              ievat=ievat+1
              itott=itott+1
              adiag(itott)=adiag(itott)+elmat(ievat+icolu)
              icolu=icolu+nevaw
            end do
          end if
        end do
        do inode=nnode+1,nnodw                              ! Secondary assemb.
          ipoin=lnods(inode)
          if(ipoin.ne.0) then
            ievat=ievat+1 
            itott=ntotm+ipoin-npoin    
            adiag(itott)=adiag(itott)+elmat(ievat+icolu)
            icolu=icolu+nevaw
          end if
        end do
      else                                                  ! Symmetric case
        ievat=0
        do inode=1,nnode                                    ! Main assembly 
          ipoin=lnods(inode)
          if(ipoin.ne.0) then
            itott=(ipoin-1)*ndofn 
            do idofn=1,ndofn             
              ievat=ievat+1
              itott=itott+1
              adiag(itott)=adiag(itott)+elmat(ievat+icolu)
              icolu=icolu+nevaw-ievat
            end do
          end if
        end do
        do inode=nnode+1,nnodw                              ! Secondary asse. 
          ipoin=lnods(inode)
          if(ipoin.ne.0) then
            ievat=ievat+1   
            itott=ntotm+ipoin-npoin  
            adiag(itott)=adiag(itott)+elmat(ievat+icolu)
            icolu=icolu+nevaw-ievat
          end if
        end do
      end if

      end
      
