      subroutine elmbve(elmat,elvec,elrhs,nevaw,ksymm)
c****************************************************************************
c
c**** This routine multiplies a elemental matrix by a vector
c
c****************************************************************************
      implicit none
      integer    nevaw,ksymm,icolu,ievaw,jevaw
      real*8     elmat(nevaw*nevaw), elvec(nevaw), elrhs(nevaw)
        
      if (ksymm.eq.0) then                                  ! Symmetric case
        icolu=0
        do jevaw=1,nevaw
          elrhs(jevaw)=0.0d0
          do ievaw=jevaw,nevaw
            elrhs(jevaw)=elrhs(jevaw)+elmat(icolu+ievaw)
     .        *elvec(ievaw)
          end do
          icolu=icolu+nevaw-jevaw
        end do
        do ievaw=2,nevaw
          icolu=0
          do jevaw=1,ievaw-1
            elrhs(ievaw)=elrhs(ievaw)+elmat(icolu+ievaw)
     .        *elvec(jevaw)
            icolu=icolu+nevaw-jevaw
          end do
        end do
      else                                                  ! Non symmetric
        do ievaw=1,nevaw                                    ! case
          icolu=0
          elrhs(ievaw)=0.0
          do jevaw=1,nevaw
            elrhs(ievaw)=elrhs(ievaw)+elmat(icolu+ievaw)
     .        *elvec(jevaw)
            icolu=icolu+nevaw
          end do
        end do
      end if

      end
