      subroutine gmrabx(
     .  eamat,lengp,x,diag,nequa,y,b,job,lnods,elpve,
     .  elwve,nevaw,nnode,nnodt,nnodw,ndofn,npoin,npois,
     .  nelem,ksymm)
c*************************************************************************
c
c**** This routine performs the following operations:
c      
c     JOB = 0 : compute Ax,
c         = 1 : compute b-Ax
c      
c**** The result is put in the vector Y
c     
c*************************************************************************   
      implicit none
      integer    eamat                                      ! pointer
      integer    nevaw,nnode,nnodt,nnodw,ndofn,npoin,
     .           npois,nelem
      integer    lnods(nnodt,nelem),job,nequa,ksymm,lengp
      integer    i
      real*8     diag(nequa), x(nequa), y(nequa), b(nequa),
     .           elpve(nevaw), elwve(nevaw)

      call mabvec(
     .  lnods,eamat,lengp,x,y,elpve,elwve,nequa,
     .  nevaw,nnode,nnodt,nnodw,ndofn,npoin,npois,
     .  nelem,ksymm)
      
      do i = 1, nequa
        y(i) = y(i) / diag(i)
      end do
      
      if (job.eq.1) then
        do i = 1, nequa
          y(i) = b(i) - y(i)
        end do
      end if

      end
