      subroutine mabvec(
     .  lnods,eamat,lengp,xvect,bvect,elxve,elbve,
     .  nequa,nevaw,nnode,nnodt,nnodw,ndofn,npoin,
     .  npois,nelem,ksymm)
c****************************************************************************
c
c**** This routine multiplies a non-assembled matrix by a vector A*x=b
c
c****************************************************************************
      implicit none
      integer   eamat,p_mat                                 ! pointer
      integer
     .  nnodt,nevaw,nnode,ndofn,nnodw,nequa,npoin,lengp,
     .  npois,ksymm,nelem,ielem,ievat,inode,itott,ntotm,
     .  idofn,iequa,ipoin
      integer   lnods(nnodt,nelem)
      real*8    elxve(nevaw), xvect(nequa), elbve(nevaw),
     .          bvect(nequa)

      ntotm=nequa-npois                                     ! = ndofn*npoin
      do iequa=1,nequa
        bvect(iequa)=0.0d0
      end do
      do ielem=1,nelem
        ievat=0                                             ! Gather of the
        do inode=1,nnode                                    ! XVECT->ELXVE
          ipoin=lnods(inode,ielem)
          if(ipoin.ne.0) then
            itott=(ipoin-1)*ndofn
            do idofn=1,ndofn
              ievat=ievat+1
              itott=itott+1
              elxve(ievat)=xvect(itott)
            end do
          end if
        end do
        do inode=nnode+1,nnodw
          ipoin=lnods(inode,ielem)
          if(ipoin.ne.0) then
            ievat=ievat+1
            itott=ntotm+ipoin-npoin
            elxve(ievat)=xvect(itott)
          end if
        end do
        call spoias(%val(eamat+(ielem-1)*lengp),p_mat)
        call elmbve(%val(p_mat),elxve,elbve,nevaw,          ! Multiply A.x=b
     .              ksymm)
        ievat=0                                             ! Scatter of the
        do inode=1,nnode                                    ! ELBVE->BVECT
          ipoin=lnods(inode,ielem)
          if(ipoin.ne.0) then
            itott=(ipoin-1)*ndofn
            do idofn=1,ndofn
              ievat=ievat+1
              itott=itott+1
              bvect(itott)=bvect(itott)+elbve(ievat)
            end do
          end if
        end do
        do inode=nnode+1,nnodw
          ipoin=lnods(inode,ielem)
          if(ipoin.ne.0) then
            ievat=ievat+1
            itott=ntotm+ipoin-npoin
            bvect(itott)=bvect(itott)+elbve(ievat)
          end if
        end do
      end do      

      end
