      subroutine mameba(
     .  lnods,lpntn,ndofn,nnode,nnodt,nnodw,
     .  nelem,npoin,ntotv,nequa,ksymm,nband,
     .  iamat,iprob,lengp,ndimt,speme,sizms,
     .  lusol)
c**********************************************************************
c                 
c**** This routine allocates memory for the system matrix when it is
c**** stored in band
c                 
c**********************************************************************
      implicit   none
      integer    iamat                                      ! pointer
      integer
     .  ndofn,nnode,nnodt,nnodw,nelem,npoin,ntotv,
     .  nequa,ksymm,nband,iprob,lengp,ndimt,speme,
     .  sizms,lusol
      integer
     .  lnods(nnodt,nelem), lpntn(ntotv)
      integer
     .  ielem,inode,ipoin,idofn,itotv,jnode,jpoin,
     .  jdofn,jtotv,iband,lbyts
c
c*** Half-bandwidth
c
      nband=0
      do ielem=1,nelem
        do inode=1,nnodw
          ipoin=lnods(inode,ielem)
          if(ipoin.gt.0) then
            idofn=0
            do while(idofn.lt.ndofn)
              if(ipoin.le.npoin) then
                idofn=idofn+1
                itotv=(ipoin-1)*ndofn+idofn
              else
                itotv=npoin*(ndofn-1)+ipoin
                idofn=ndofn
              end if
              if (lpntn(itotv).gt.0) then
                do jnode=inode+1,nnodw
                  jpoin=lnods(jnode,ielem)
                  if(jpoin.gt.0) then
                    jdofn=0
                    do while(jdofn.lt.ndofn)
                      if(jpoin.le.npoin) then
                        jdofn=jdofn+1
                        jtotv=(jpoin-1)*ndofn+jdofn
                      else
                        jtotv=npoin*(ndofn-1)+jpoin
                        jdofn=ndofn
                      end if
                      if(lpntn(jtotv).gt.0)
     .                  iband=abs(lpntn(itotv)-lpntn(jtotv))
                      if(iband.gt.nband) nband=iband
                    end do
                  end if
                end do
              end if
            end do
          end if
        end do
      end do
c
c*** Memory allocation
c
      ndimt=(nband*(1+ksymm)+1)*nequa
      lbyts=ndimt*8
      call matpoi(iprob,iamat,lengp,sizms,speme,lbyts)
c
c*** Write solver information
c
      write(lusol,900) nband,ndimt 
      
  900 format(11x,'*** HALF BANDWIDTH              :',i10,/
     .       11x,'*** SIZE OF THE MATRIX          :',i10,' (R*8)')
      
      end
