      subroutine mamelm(eamat,ksymm,nnode,nnodw,ndofn,nelem,
     .                  lures,lengp,speme)
c*************************************************************************
c                 
c**** This routine allocates memory for the elemental matrices when they
c**** are stored for iterative solvers
c                 
c*************************************************************************
      implicit none
      integer       ksymm,nnode,nnodw,ndofn,nelem,nevat,
     .              ndimt,ielem,lures,lengp,speme
      integer       eamat,p_mat                             ! pointer
      
      nevat=(nnode*ndofn+nnodw-nnode)
      ndimt=(ksymm+1)*(nevat*nevat-nevat)/2+nevat
      do ielem=1,nelem
        call sadmem(0,p_mat,ndimt*8,speme)
        call spoias(p_mat,%val(eamat+(ielem-1)*lengp))
        call svecze(ndimt,%val(p_mat))
      end do
      p_mat=0
      call spoias(p_mat,%val(eamat+nelem*lengp))

      write(lures,900) nelem,ndimt

  900 format(11x,'*** NUMBER OF ELEMENT MATRICES  :',i10,/
     .       11x,'*** SIZE OF EACH ELEMENT MATRIX :',i10,' (R*8)')

      end
