      subroutine mamepr(lpont,nequa,ntotv,ksymm,ndimt,iamat,
     .                  iprob,lengp,speme,sizms,lusol)
c**********************************************************************
c                 
c**** This routine allocates memory for the system matrix when it is
c**** stored in profile
c                 
c**********************************************************************
      implicit   none
      integer    speme,nlast,nequa,ntotv,meanh,nsizz,
     .           ksymm,ndimt,iprob,lengp,lbyts,lusol,
     .           sizms
      integer    iamat                                      ! pointer
      real*8     hmean
      integer    lpont(ntotv)
c
c*** Write solver information
c
      hmean=0.0
      nlast=lpont(nequa)
      if(nequa.ne.0) hmean=float(nlast+nequa)/float(nequa)
      meanh=nint(hmean)
      nsizz=nequa+nlast*(1+ksymm)
      write(lusol,900) meanh,nsizz
c
c*** Allocate memory
c      
      ndimt=nequa+(1+ksymm)*nlast
      lbyts=8*ndimt
      call matpoi(iprob,iamat,lengp,sizms,speme,lbyts)
c
c*** Formats
c
  900 format(11x,'*** MEAN HALF-WIDTH             :',i10,/
     .       11x,'*** SIZE OF THE MATRIX          :',i10,' (R*8)')

      end
