      subroutine nelepo(p_lelpo,nepoi,lnods,nelem,nnodw,nnodt,
     .                  npoit  ,lengp,svomt,itask)
c**********************************************************************
c                 
c**** This routine computes the number of elements to which the nodal
c**** points belong and allocates or deallocates memory for the list 
c                 
c**********************************************************************
      implicit none
      integer nelem,nnodt,npoit,ielem,inode,ipoin,lbyts,
     .        lengp,svomt,nnodw,itask
      integer nepoi(npoit), lnods(nnodt,nelem)
      integer p_lelpo,p_ele                                 ! pointer
c
c*** Number of elements per nodal point
c
      if(itask.eq.1) then
        call slvecz(npoit,nepoi)
        do ielem=1,nelem
          do inode=1,nnodw
            ipoin=lnods(inode,ielem)
            if(ipoin.gt.0)
     .        nepoi(ipoin)=nepoi(ipoin)+1
          end do
        end do
c
c*** Allocate memory for the list of elements
c
        do ipoin=1,npoit
          lbyts=lengp*nepoi(ipoin)
          call sadmem(0,p_ele,lbyts,svomt)
          call spoias(p_ele,%val(p_lelpo+(ipoin-1)*lengp))
          call slvecz(nepoi(ipoin),%val(p_ele))
        end do
      else if(itask.eq.2) then
c
c*** Deallocate memory for the list of elements
c
        do ipoin=1,npoit
          lbyts=lengp*nepoi(ipoin)
          call spoias(%val(p_lelpo+(ipoin-1)*lengp),p_ele)
          call sadmem(2,p_ele,lbyts,svomt)
        end do
      end if
        
      end
