      subroutine renum4(ndeg,lev,lsd,nadj,mlw,nodes,nroot,nloc)
c**********************************************************************
c
c**** Compute level structure rooted at nroot
c
c**********************************************************************
      implicit real*8 (a-h,o-z)
      logical*1 back
      integer   lev(*),ndeg(*),nadj(*)
c
c*** Initialization
c
      do i = 1,nodes
        lev(i) = 0
      end do
      lev(nroot) = 1    
      ndeg(1) = nroot
      back = .false.
      lsd = 1
      kount = 1
      nloc = 1
      nlocn = 0
      mlw = 1
c
c*** Assign levels
c
      do while(kount.lt.nodes)
        do il = 1,nloc
          if(.not.back) ip = ndeg(il)
          if(back) ip = ndeg(nodes+1-il)
          nad = nadj(ip)
          do while (nad.gt.0)
            jp = nadj(nad)
            if(lev(jp).eq.0) then
              nlocn = nlocn + 1
              lev(jp) = lsd + 1
              kount = kount + 1
              if(back) ndeg(nlocn) = jp
              if(.not.back) ndeg(nodes+1-nlocn) = jp
            end if
            nad = nadj(nad+1)
          end do
        end do
        nloc = nlocn
        nlocn = 0
        if(nloc.gt.mlw) mlw = nloc
        lsd = lsd + 1
        back = .not.back
      end do

      if(back) then
        nhalf = nodes/2
        do i = 1,nhalf
          nn = ndeg(i)
          ndeg(i) = ndeg(nodes+1-i)
          ndeg(nodes+1-i) = nn
        end do
      end if

      end


