      subroutine macopr(value,idest,jdest,xmatr,lpont,nequa,ksymm)
c************************************************************************
c                 
c**** This routine assembles a scalar VALUE to the proper position of 
c**** a skyline matrix XMATR
c                 
c************************************************************************
      implicit   real*8(a-h,o-z)
      integer    lpont(*)
      real*8     xmatr(*)              ! xmatr(nequa+lpont(nequa)*(1+ksymm))

      if (idest.eq.jdest) then                              ! Diagonal terms
        xmatr(idest)=xmatr(idest)+value
      else if (idest.lt.jdest) then                         ! Upper matrix
        jloca=idest+lpont(jdest)-jdest+1+nequa
        xmatr(jloca)=xmatr(jloca)+value
      else if (ksymm.eq.1) then                             ! Lower matrix
        jloca=jdest+lpont(idest)-idest+1+nequa+lpont(nequa)
        xmatr(jloca)=xmatr(jloca)+value
      end if

      end
