      subroutine stomat(elmat,nvalo,nevaw,ielem,nelem,ksymm,
     .                  iamat,lengp,kmadi)
c*****************************************************************************
c
c**** This routine stores the elemental matrices for iterative solvers
c
c*****************************************************************************
      implicit none
      integer   nvalo,nevaw,ksymm,ielem,nelem,lengp,
     .          kmadi,ndimt,jelem
      integer   iamat,p_mat                                 ! pointer
      real*8    elmat(nvalo,nvalo)
c
c*** If needed, clear the space for the element matrices
c
      if(kmadi.eq.1) then
        ndimt=(1+ksymm)*(nevaw*nevaw-nevaw)/2+nevaw           
        do jelem=1,nelem                            
          call spoias(%val(iamat+(jelem-1)*lengp),p_mat)
          call svecze(ndimt,%val(p_mat))
        end do
        kmadi=-1
      end if
c
c*** Store the matrix of element IELEM
c
      call spoias(%val(iamat+(ielem-1)*lengp),p_mat)
      call putmat(%val(p_mat),elmat,nvalo,nevaw,ksymm)

      end



