      subroutine batosp(nequa,nband,banma,spama,lncol,lnrow,
     .                  nonze,multi,ksymm,bvect)
c****************************************************************************
c
c*** This routine stores a banded matrix BANMA in sparse form SPAMA
c
c***************************************************************************
      implicit real*8(a-h,o-z)
      real*8    banma(nband*(1+ksymm)+1,nequa), spama(multi*nonze),
     .          bvect(nequa)
      integer   lncol(multi*nonze), lnrow(multi*nonze)
      
      iasse=0
      do iband=ksymm*nband+1,ksymm*nband+nband+1
        do iequa=1,nequa
          if (abs(banma(iband,iequa)).gt.1.0d-12) then
            jdest=iequa
            idest=iband-ksymm*nband-1+jdest
            iasse=iasse+1
            spama(iasse)=banma(iband,iequa)
            lncol(iasse)=jdest
            lnrow(iasse)=idest
            if (ksymm.eq.0) then
              if (idest.ne.jdest) then
                iasse=iasse+1
                spama(iasse)=banma(iband,iequa)
                lncol(iasse)=idest
                lnrow(iasse)=jdest
              end if
            end if
           end if 
         end do
       end do
       if (ksymm.eq.1) then
         do iband=1,nband
           do iequa=1,nequa
             if (abs(banma(iband,iequa)).gt.1.0d-12) then
               idest=iequa
               jdest=-iband+nband+1+idest
               iasse=iasse+1
               spama(iasse)=banma(iband,iequa)
               lncol(iasse)=jdest
               lnrow(iasse)=idest
             end if
           end do
         end do
       end if

       do iasse=nonze+1,multi*nonze
         spama(iasse)=0.0d0
         lncol(iasse)=0
         lnrow(iasse)=0
       end do

      end
