      subroutine crobde(n,l,a,c,iu)
c****************************************************************************
c
c*** This routine performs the Crout descomposition of a matrix `A'
c*** of bandwidth `l' and `n' rows. The resulting matrix is  `C'. Errors
c*** are printed in unit `iu'
c
c****************************************************************************
      implicit real*8(a-h,o-z)
      real*8  a(2*l+1,n),c(2*l+1,n)

      nb=l+1
      id=l+1
      do m = 1,n
        rleup=0.0
        l1=1
        if (m-l.gt.1) l1=m-l
        do lj=l1,m-1
          rleup=rleup+c(id+m-lj,lj)*c(id+lj-m,lj)
        end do
        c(id,m)=a(id,m)-rleup
        if (c(id,m).eq.0.0)
     .    call srunen('CROBDE: PIVOTING IS NEEDED',iu)
        do i=m+1,nb+m-1
          rleup=0.0
          l1=1
          if (i-l.gt.1) l1=i-l
          do lj=l1,m-1
            rleup=rleup+c(id+i-lj,lj)*c(id+lj-m,lj)
          end do
          c(id+i-m,m)=a(id+i-m,m)-rleup
        end do
        do j=m+1,nb+m-1
          rleup=0.0
          l1=1
          if(j-l.gt.1) l1=j-l
          do lj=l1,m-1
            rleup=rleup+c(id+m-lj,lj)*c(id+lj-j,lj)
          end do
          c(id+m-j,m)=1/c(id,m)*(a(id+m-j,m)-rleup)
        end do
      end do

      end





