      subroutine modrhs(lpntn,roffs,apcol,unkno,rhsax,apmat,
     .                  ntotv,nzeco,nsist,nequa,iflag,zeroc)
c****************************************************************************
c
c**** This routine computes the product A_p x_p when a direct solver
c**** is used.       
c
c****************************************************************************
      implicit none
      integer   ntotv,iflag,itotv,itotn,jtotv,izec0,izec1,izeco,
     .          nzeco,isist,nsist,nequa,izecn
      integer   lpntn(ntotv), roffs(ntotv+1), apcol(nzeco)
      logical*1 first
      real*8    xcomp,zeroc
      real*8    apmat(nzeco),       unkno(ntotv,nsist),
     .          rhsax(ntotv,nsist)
c
c*** Initialization
c
      iflag=0
      first=.false.
      call svecze(nsist*ntotv,rhsax)
      do isist=1,nsist
c
c*** Check if x_p is zero or not 
c
        do itotv=1,ntotv
          if (lpntn(itotv).lt.0) then
            itotn=-lpntn(itotv)
            xcomp=unkno(itotv,isist)
            xcomp=xcomp*xcomp
            if(xcomp.gt.zeroc) iflag=1
          end if
        end do
c
c*** Compute the product A_p x_p
c
        if(iflag.eq.1) then
          do itotv=1,ntotv
            izec0=roffs(itotv)
            if(izec0.gt.0) then
              if(.not.first) then
                jtotv=itotv+1
                izecn=roffs(jtotv)
                do while(izecn.eq.0)
                  jtotv=jtotv+1
                  izecn=roffs(jtotv)
                end do
                if(izecn.gt.izec0) first=.true.
              end if
              if(first) then
                jtotv=itotv+1
                izec1=roffs(jtotv)-1
                do while(izec1.le.0)
                  jtotv=jtotv+1
                  izec1=roffs(jtotv)-1
                end do
                do izeco=izec0,izec1
                  jtotv=apcol(izeco)
                  rhsax(itotv,isist)=rhsax(itotv,isist)
     .              +apmat(izeco)*unkno(jtotv,isist)
                end do
              end if
            end if
          end do
        end if
      end do

      end
