      subroutine reduit(unkno,lpntn,rwork,ntotv,nequa,nsist,itask)
c****************************************************************************
c
c**** This routine redefines the vector of unknowns according to the 
c**** renumbering strategy for SK iterative solvers
c
c****************************************************************************
      implicit none
      integer  ntotv,nequa,nsist,itask,isist,ipres,itotv,itotn
      real*8   unkno(ntotv,nsist), rwork(ntotv,nsist)
      integer  lpntn(ntotv)

      call srveca(ntotv*nsist,unkno,rwork) 
c
c*** Original UNKNO ---> Modified UNKNO
c      
      if(itask.eq.1) then
        do isist=1,nsist
          ipres=nequa
          do itotv=1,ntotv
            itotn=lpntn(itotv)
            if (itotn.gt.0) then
              unkno(itotn,isist)=rwork(itotv,isist)
            else if(itotn.le.0) then
              ipres=ipres+1
              unkno(ipres,isist)=rwork(itotv,isist)
            end if
          end do
        end do
c
c*** Modified UNKNO ---> Original UNKNO
c      
      else if(itask.eq.2) then
        do isist=1,nsist
          ipres=nequa
          do itotv=1,ntotv
            itotn=lpntn(itotv)
            if (itotn.gt.0) then
              unkno(itotv,isist)=rwork(itotn,isist)
            else if(itotn.le.0) then
              ipres=ipres+1
              unkno(itotv,isist)=rwork(ipres,isist)
            end if
          end do
        end do
      end if
      
      end
