      subroutine mamesp(
     .  nequa,lnods,lpntn,nnodt,nelem,nnodw,
     .  npoin,ntotv,ndofn,nonze,ndimt,iamat,
     .  incol,inrow,lengp,speme)
c**********************************************************************
c                 
c**** This routine allocates memory for the system matrix when it is
c**** stored in sparse
c                 
c**********************************************************************
      implicit   real*8(a-h,o-z)
      integer    lnods(nnodt,nelem), lpntn(ntotv)
      integer    speme,lengp

      nonze=0
      do ielem=1,nelem
        do inode=1,nnodw
          ipoin=lnods(inode,ielem)
          if(ipoin.gt.0) then
            idofn=0
            do while(idofn.lt.ndofn)
              if(ipoin.le.npoin) then
                idofn=idofn+1
                itotv=(ipoin-1)*ndofn+idofn
              else
                itotv=npoin*(ndofn-1)+ipoin
                idofn=ndofn
              end if
              if (lpntn(itotv).gt.0) then
                do jnode=inode,nnodw
                  jpoin=lnods(jnode,ielem)
                  if(jpoin.gt.0) then
                    jdofn=0
                    do while(jdofn.lt.ndofn)
                      if(jpoin.le.npoin) then
                        jdofn=jdofn+1
                        jtotv=(jpoin-1)*ndofn+jdofn
                      else
                        jtotv=npoin*(ndofn-1)+jpoin
                        jdofn=ndofn
                      end if
                      if(lpntn(jtotv).gt.0)
     .                  nonze=nonze+1
                    end do
                  end if
                end do
              end if
            end do
          end if
        end do
      end do
      nonze=nonze*2
c
c*** Memory allocation
c
      ndimt=nonze*3
      lbyts=ndimt*8
      call sadmem(0,iamat,lbyts,speme)
      lbyts=ndimt*lengp
      call sadmem(0,incol,lbyts,speme)
      lbyts=ndimt*lengp
      call sadmem(0,inrow,lbyts,speme)
      nonze=0
      
      end
