      subroutine optban(lpoin,lcone,numco,lolne,lneol,nnodt,
     .                  nnode,nelem,npoin,mxcon,nband)
c***************************************************************************   
c
c*** This routine optimizes the bandwidth.  LPOIN(I) contains the new node
c*** number for the old node I
c
c**************************************************************************** 
      integer   lpoin(npoin),numco(npoin),lcone(npoin,mxcon),
     .          lolne(npoin),lneol(npoin)

      do ipoin=1,npoin                                      ! Initializes LPOIN
        lpoin(ipoin)=ipoin
      end do

      do ipoin=1,npoin                                      ! Start the renum.
        do kpoin=1,npoin                                    ! with each nodal
          lolne(kpoin)=0                                    ! point. Initia-
          lneol(kpoin)=0                                    ! lizes LOLNE LNEOL
        end do
        iband=0
        lneol(1)=ipoin
        lolne(ipoin)=1
        nasig=1
        ineol=0
        do while(nasig.ne.npoin)
          ineol=ineol+1
          icone=0
          do while(icone.ne.numco(lneol(ineol)))
            icone=icone+1
            jpoin=lcone(lneol(ineol),icone)
            if (lolne(jpoin).eq.0) then
              nasig=nasig+1
              lolne(jpoin)=nasig
              lneol(nasig)=jpoin
              iband=max(iband,abs(ineol-nasig))
              if (iband.gt.nband) then
                icone=numco(lneol(ineol))
                nasig=npoin
              end if
            end if
          end do
        end do
        if (iband.lt.nband) then
          nband=iband
          do kpoin=1,npoin
            lpoin(kpoin)=lneol(kpoin)
          end do
        end if
      end do
      
      end
