      subroutine setcon(lnods,lcone,numco,npoin,nnodt,nnode,nelem,
     .                  mxcon,nband)
c*************************************************************************
c
c*** This routine builds the conectivity arrays NUMCO and LCONE,
c*** and computes the initial bandwidth. The arrays are:
c*** NUMCO(I)   contains the number of nodes related with node I
c*** LCONE(I,J) contains the identities of those nodes
c      
c*************************************************************************
      logical   assig
      integer   lnods(nnodt,nelem),numco(npoin),lcone(npoin,mxcon)

      nband=0
      do ipoin=1,npoin
        numco(ipoin)=0
      end do
      
      do ielem=1,nelem
        do inode=1,nnode
          ipoin=lnods(inode,ielem)
          if(ipoin.ne.0) then
            do jnode=1,nnode
              jpoin=lnods(jnode,ielem)
              if ((ipoin.ne.jpoin).and.(jpoin.ne.0)) then
                assig=.true.
                icone=1
                do while((assig).and.(icone.le.numco(ipoin)))
                  if (lcone(ipoin,icone).eq.jpoin) assig=.false.
                  icone=icone+1
                end do
                if (assig) then
                  numco(ipoin)=icone
                  lcone(ipoin,icone)=jpoin
                  iband=abs(ipoin-jpoin)
                  if (iband.gt.nband) nband=iband
                end if
              end if
            end do
          end if
        end do
      end do

      do ipoin=1,npoin
        do icone=1,numco(ipoin)-1
          do jcone=icone+1,numco(ipoin)
            if (numco(lcone(ipoin,icone)).gt.
     .        numco(lcone(ipoin,jcone))) then
              itemp=lcone(ipoin,icone)
              lcone(ipoin,icone)=lcone(ipoin,jcone)
              lcone(ipoin,jcone)=itemp
            end if
          end do
        end do
      end do

      end
