      subroutine setdat
c**********************************************************************
c                 
c**** This routine initializes some data
c                 
c**********************************************************************
      implicit none
      include   'MatMan.h'
      integer kprob
c
c*** Type of solver family
c      
      do kprob=1,mprob
        if (     (kites(kprob).gt.10)
     .    .and.  (kites(kprob).le.20)) then                 ! Direct solvers
          sofam(kprob) = 1
        else if( (kites(kprob).gt.20)
     .      .and.(kites(kprob).le.30)) then                 ! EE Iterative solvers
          sofam(kprob) = 2
        else if( (kites(kprob).gt.30)
     .      .and.(kites(kprob).le.40)) then                 ! SK Iterative solvers
          sofam(kprob) = 3
        else
          if(kites(kprob).ne.0) 
     .      call srunei(
     .      'SETDAT: WRONG TYPE OF SOLVER FOR PROBLEM',
     .      kprob,lusol)
        end if
c
c*** Initialization of some flags
c
        if((sofam(kprob).eq.2).and.(kmsip(kprob).gt.0))
     .    kmsip(kprob) = -1                                 ! No prec. by default
      end do
      
      end
